FROM golang:1.24-alpine AS builder

ARG BUILD_LDFLAGS
WORKDIR /app

COPY go.mod go.sum ./
RUN go mod download -x

COPY . .

RUN CGO_ENABLED=0 GOOS=linux go build -ldflags="${BUILD_LDFLAGS}" -trimpath -o main ./cmd/main.go

FROM alpine:3.18 AS certs
RUN wget -q "https://storage.yandexcloud.net/cloud-certs/CA.pem" -O /YandexInternalRootCA.crt \
    && chmod 0655 /YandexInternalRootCA.crt

FROM alpine:3.18
WORKDIR /
ARG CONFIG_FILE_PATH


RUN apk add --no-cache ca-certificates tzdata

COPY --from=certs /YandexInternalRootCA.crt /etc/.redis/YandexInternalRootCA.crt
COPY --from=certs /YandexInternalRootCA.crt /etc/.postgres/YandexInternalRootCA.crt
COPY ${CONFIG_FILE_PATH} /config.yaml

COPY --from=builder /app/main /main

RUN adduser -D -u 10001 appuser && chown appuser /main
USER appuser

ENTRYPOINT ["/main"]
CMD ["--config_path", "/config.yaml"]